import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import './styles.css';
import * as wijmo from '@mescius/wijmo';
import * as grid from '@mescius/wijmo.grid';
import * as chart from '@mescius/wijmo.chart';
import '@mescius/wijmo.chart.render';
import * as pdf from '@mescius/wijmo.pdf';
import * as gridPdf from '@mescius/wijmo.grid.pdf';
import { getData, getExpenses } from './data';
//
document.readyState === 'complete' ? init() : window.onload = init;
const docName = 'FlexGrid.pdf';
//
function init() {
const exportSettings = {
styles: {
cellStyle: {
backgroundColor: '#ffffff',
borderColor: '#c6c6c6'
},
altCellStyle: {
backgroundColor: '#f9f9f9'
},
groupCellStyle: {
backgroundColor: '#dddddd'
},
headerCellStyle: {
backgroundColor: '#eaeaea'
}
}
};
const data = getData(1500);
//
initExportGridSample(exportSettings, data);
initExportSample(exportSettings, data);
initApiSample(exportSettings, data);
}
//
//
function initExportGridSample(exportSettings, data) {
let flexGrid = new grid.FlexGrid('#flexGrid1', {
autoGenerateColumns: false,
selectionMode: grid.SelectionMode.ListBox,
headersVisibility: grid.HeadersVisibility.All,
columns: [
{ header: 'ID', binding: 'id' },
{ header: 'Start Date', binding: 'start', format: 'd' },
{ header: 'End Date', binding: 'end', format: 'd' },
{ header: 'Country', binding: 'country' },
{ header: 'Product', binding: 'product' },
{ header: 'Amount', binding: 'amount', format: 'c' },
{ header: 'Color', binding: 'color' },
{ header: 'Pending', binding: 'amount2', format: 'c2' },
{ header: 'Discount', binding: 'discount', format: 'p1' },
{ header: 'Active', binding: 'active' }
],
itemsSource: data
});
//
let ctx = {
exporting: false,
progress: 0,
preparing: false,
worker: null,
grid: flexGrid,
button: document.querySelector('#btnExport1'),
progressEl: document.querySelector('#txtProgress1')
};
//
ctx.button.addEventListener('click', () => {
if (!ctx.exporting) {
start(ctx, './export-grid', () => {
gridPdf.PdfWebWorkerClient.exportGrid(ctx.worker, flexGrid, docName, exportSettings, null, (prgVal) => {
progress(ctx, prgVal);
});
});
}
else {
cancel(ctx);
}
});
//
window.addEventListener('unload', () => {
if (ctx.worker) {
ctx.worker.terminate();
ctx.worker = null;
}
});
}
//
//
function initExportSample(exportSettings, data) {
let flexPie = new chart.FlexPie('#flexPie', {
itemsSource: ((totals) => [
{ name: 'Hotel', value: totals.hotel },
{ name: 'Transport', value: totals.transport },
{ name: 'Meal', value: totals.meal },
{ name: 'Fuel', value: totals.fuel },
{ name: 'Misc', value: totals.Misc }
])(getExpenses().totals),
binding: 'value',
bindingName: 'name',
innerRadius: 0.75,
dataLabel: {
content: '{value:c1}',
position: chart.PieLabelPosition.Inside
}
});
//
let flexGrid = new grid.FlexGrid('#flexGrid2', {
autoGenerateColumns: false,
selectionMode: grid.SelectionMode.ListBox,
headersVisibility: grid.HeadersVisibility.All,
columns: [
{ header: 'ID', binding: 'id' },
{ header: 'Start Date', binding: 'start', format: 'd' },
{ header: 'End Date', binding: 'end', format: 'd' },
{ header: 'Country', binding: 'country' },
{ header: 'Product', binding: 'product' },
{ header: 'Amount', binding: 'amount', format: 'c' },
{ header: 'Color', binding: 'color' },
{ header: 'Pending', binding: 'amount2', format: 'c2' },
{ header: 'Discount', binding: 'discount', format: 'p1' },
{ header: 'Active', binding: 'active' }
],
itemsSource: data
});
//
let ctx = {
exporting: false,
progress: 0,
preparing: false,
worker: null,
grid: flexGrid,
button: document.querySelector('#btnExport2'),
progressEl: document.querySelector('#txtProgress2')
};
//
ctx.button.addEventListener('click', () => {
if (!ctx.exporting) {
start(ctx, './export', () => {
gridPdf.PdfWebWorkerClient.addString(ctx.worker, 'Title', 'title');
gridPdf.PdfWebWorkerClient.addImage(ctx.worker, 'resources/canada.png', 'flag', null);
flexPie.saveImageToDataUrl(chart.ImageFormat.Svg, (url) => {
gridPdf.PdfWebWorkerClient.addImage(ctx.worker, url, 'chart', null);
});
gridPdf.PdfWebWorkerClient.addGrid(ctx.worker, flexGrid, 'grid', exportSettings);
//
gridPdf.PdfWebWorkerClient.export(ctx.worker, null, (data) => pdf.saveBlob(data.blob, docName), (prgVal) => progress(ctx, prgVal));
});
}
else {
cancel(ctx);
}
});
//
window.addEventListener('unload', () => {
if (ctx.worker) {
ctx.worker.terminate();
ctx.worker = null;
}
});
}
//
//
function initApiSample(exportSettings, data) {
let flexGrid = new grid.FlexGrid('#flexGrid3', {
autoGenerateColumns: false,
selectionMode: grid.SelectionMode.ListBox,
headersVisibility: grid.HeadersVisibility.All,
columns: [
{ header: 'ID', binding: 'id' },
{ header: 'Start Date', binding: 'start', format: 'd' },
{ header: 'End Date', binding: 'end', format: 'd' },
{ header: 'Country', binding: 'country' },
{ header: 'Product', binding: 'product' },
{ header: 'Amount', binding: 'amount', format: 'c' },
{ header: 'Color', binding: 'color' },
{ header: 'Pending', binding: 'amount2', format: 'c2' },
{ header: 'Discount', binding: 'discount', format: 'p1' },
{ header: 'Active', binding: 'active' }
],
itemsSource: data
});
//
let ctx = {
exporting: false,
progress: 0,
preparing: false,
worker: null,
grid: flexGrid,
button: document.querySelector('#btnExport3'),
progressEl: document.querySelector('#txtProgress3')
};
//
ctx.button.addEventListener('click', () => {
if (!ctx.exporting) {
start(ctx, './api', () => {
ctx.worker.addEventListener('message', (e) => {
if (e.data.type === 'progress') {
progress(ctx, e.data.value);
}
else {
pdf.saveBlob(new Blob([new Uint8Array(e.data.data)], { type: 'application/pdf' }), docName);
}
});
//
var gridData = gridPdf.PdfWebWorkerClient.serializeGrid(flexGrid, exportSettings);
// Send gridData as a tranferable object
ctx.worker.postMessage({ grid: gridData, settings: JSON.stringify(exportSettings) }, [gridData]);
});
}
else {
cancel(ctx);
}
});
//
window.addEventListener('unload', () => {
if (ctx.worker) {
ctx.worker.terminate();
ctx.worker = null;
}
});
}
//
function start(ctx, url, ready) {
ctx.preparing = true;
ctx.progress = 0;
updateUI(ctx);
//
ctx.worker = loadWorker(url, () => ready());
}
//
function progress(ctx, progress) {
if (progress === 0 || progress === 1) {
ctx.preparing = false;
ctx.exporting = progress === 0;
}
ctx.progress = progress;
//
updateUI(ctx);
}
//
function cancel(ctx) {
ctx.worker.terminate();
ctx.worker = null;
ctx.exporting = false;
ctx.progress = 0;
//
updateUI(ctx);
}
//
/**
* Creates web worker that executes the module from the specified URL.
* @param url The module URL, relative to the src/workers directory.
* @param ready
*/
function loadWorker(url, ready) {
let worker = new Worker('src/workers/worker-loader.js');
//
worker.addEventListener('message', (e) => {
if (e.data === '#ready#') {
ready();
}
});
//
worker.postMessage({ url: url });
//
return worker;
}
//
function updateUI(ctx) {
ctx.grid.isDisabled = ctx.preparing;
wijmo.enable(ctx.button, !ctx.preparing);
ctx.button.textContent = ctx.exporting ? 'Cancel' : 'Export';
ctx.progressEl.textContent = (ctx.progress * 100).toFixed(1) + '%';
}
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>Web Workers</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.5/dist/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app');
</script>
</head>
<body>
<main class="container-fluid">
<p>
This sample demonstrates the "Simple single grid export" scenario and shows how to export FlexGrid in
a background thread.
</p>
<button class="btn btn-default" id="btnExport1">Export</button>
<span id="txtProgress1">0%</span>
<div id="flexGrid1" class="grid"></div>
<hr />
<p>
This sample demonstrates the "Custom document generation" scenario and shows how to export FlexPie
(as a SVG image), FlexGrid and PNG image to a PDF in a background thread.
</p>
<p>
The <a href="https://www.npmjs.com/package/xmldom">xmldom</a> library is used here to bring DOM
support to the server to be able to draw SVG.
</p>
<button class="btn btn-default" id="btnExport2">Export</button>
<span id="txtProgress2">0%</span>
<p></p>
<div class="row">
<div class="col-md-6">
<div id="flexPie"></div>
</div>
<div class="col-md-6">
<div id="flexGrid2" class="grid"></div>
</div>
</div>
<hr />
<p>
This sample demonstrates the "Low-level usage of Web Workers API" scenario and shows how to export
FlexGrid to a PDF in a background thread using Web Workers API.
</p>
<button class="btn btn-default" id="btnExport3">Export</button>
<span id="txtProgress3">0%</span>
<div id="flexGrid3" class="grid"></div>
</main>
</body>
</html>
export function getData(count) {
// data used to generate random items
const countries = ['US', 'Germany', 'UK', 'Japan', 'Italy', 'Greece'];
const products = ['Widget', 'Gadget', 'Doohickey'];
const colors = ['Orange', 'White', 'Red', 'Green', 'Blue'];
//
let data = [];
let dt = new Date();
//
// add count items
for (let i = 0; i < count; i++) {
// constants used to create data items
let date = new Date(dt.getFullYear(), i % 12, 25, i % 24, i % 60, i % 60), countryId = Math.floor(Math.random() * countries.length), productId = Math.floor(Math.random() * products.length), colorId = Math.floor(Math.random() * colors.length);
//
// create the item
let item = {
id: i,
start: date,
end: date,
country: countries[countryId],
product: products[productId],
color: colors[colorId],
amount: Math.random() * 10000 - 5000,
amount2: Math.random() * 10000 - 5000,
discount: Math.random() / 4,
active: i % 4 == 0,
};
//
// add the item to the list
data.push(item);
}
return data;
}
//
export function getExpenses() {
// [5; 10]
let count = 5 + Math.round(Math.random() * 5), ret = {
items: [],
totals: { hotel: 0, transport: 0, fuel: 0, meal: 0, Misc: 0, total: 0 }
}, msPerDay = 1000 * 24 * 60 * 60, curDate = Date.now() - 60 * msPerDay;
//
for (let i = 0; i < count; i++) {
let item = {
date: new Date(curDate),
description: 'Customer visit',
hotel: 30 + Math.random() * 200,
transport: 10 + Math.random() * 150,
fuel: Math.random() * 50,
meal: 30 + Math.random() * 170,
Misc: Math.random() * 220,
total: 0
};
//
item.total = item.hotel + item.transport + item.fuel + item.meal + item.Misc;
//
ret.totals.fuel += item.fuel;
ret.totals.hotel += item.hotel;
ret.totals.meal += item.meal;
ret.totals.Misc += item.Misc;
ret.totals.total += item.total;
ret.totals.transport += item.transport;
//
ret.items.push(item);
//
curDate += msPerDay * Math.round(Math.random() * 4);
}
//
return ret;
}
body {
margin-bottom: 24px;
}
.grid {
margin-top: 20px;
height: 200px;
}
.wj-flexpie {
height: 250px;
}
import { PdfWebWorker } from '@mescius/wijmo.grid.pdf';
//
PdfWebWorker.initExportGrid();
var _a;
import * as xmldom from '@xmldom/xmldom';
import * as gridPdf from '@mescius/wijmo.grid.pdf';
//
self.DOMParser = ((_a = xmldom.default) === null || _a === void 0 ? void 0 : _a.DOMParser) || xmldom.DOMParser;
//
gridPdf.PdfWebWorker.initExport((doc, clientData) => {
gridPdf.PdfWebWorker.sendExportProgress(0);
//
doc.drawText(clientData['title'].content);
doc.drawImage(clientData['flag'].content);
doc.drawSvg(clientData['chart'].content);
//
// Suppose that text and images rendering takes 5% of the time.
gridPdf.PdfWebWorker.sendExportProgress(0.05);
//
let gridData = clientData['grid'];
gridData.settings.progress = (value) => {
// Change progress from 6% to 90%. Left the final 10% for the document finalization, which will start after the doc.end() method is called.
gridPdf.PdfWebWorker.sendExportProgress(map(value, 0, 1, 0.06, 0.9));
};
//
doc.ended.addHandler(() => {
// Document has been created, set progress to 100%.
gridPdf.PdfWebWorker.sendExportProgress(1);
});
//
gridPdf.FlexGridPdfConverter.draw(gridData.content, doc, null, null, gridData.settings);
//
doc.end();
});
//
function map(value, inMin, inMax, outMin, outMax) {
let k = (outMax - outMin) / (inMax - inMin);
return (value - inMin) * k + outMin;
}
//
import * as pdf from '@mescius/wijmo.pdf';
import * as gridPdf from '@mescius/wijmo.grid.pdf';
//
addEventListener('message', (e) => {
let json = e.data.grid, settings = JSON.parse(e.data.settings);
//
settings.documentOptions = settings.documentOptions || {};
//
settings.documentOptions.ended = (sender, args) => {
postProgress(1); // 100%
//
// Convert Blob to a transferable object...
let fileReader = new FileReader();
fileReader.onload = (e) => {
let buffer = e.target.result;
// ...and send it to client.
postMessage({ data: buffer }, [buffer]);
};
fileReader.readAsArrayBuffer(args.blob);
};
//
settings.progress = (value) => {
postProgress(value * 0.9); // 0% to 90%
};
//
let doc = new pdf.PdfDocument(settings.documentOptions), grid = gridPdf.PdfWebWorker.deserializeGrid(json, settings);
//
gridPdf.FlexGridPdfConverter.draw(grid, doc, null, null, settings);
//
doc.end();
});
//
function postProgress(value) {
postMessage({ type: 'progress', value: value });
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
},
meta: {
'*.css': { loader: 'css' },
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/wijmojs/5.20261.50-rc/',
'pcdn:': 'https://cdn.jsdelivr.net/npm/'
},
// map tells the System loader where to look for things
map: {
'@mescius/wijmo': 'cdn:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'cdn:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'cdn:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'cdn:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'cdn:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'cdn:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'cdn:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'cdn:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'cdn:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'cdn:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'cdn:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'cdn:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'cdn:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'cdn:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'cdn:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'cdn:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'cdn:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'cdn:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'cdn:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'cdn:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'cdn:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'cdn:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'cdn:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'cdn:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'cdn:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'cdn:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'cdn:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'cdn:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'cdn:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'cdn:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'cdn:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'cdn:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'cdn:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'cdn:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'cdn:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'cdn:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'cdn:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'cdn:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'cdn:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'cdn:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'cdn:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'cdn:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'cdn:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'cdn:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'cdn:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'cdn:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'cdn:@mescius/wijmo.barcode.specialized/index.js',
jszip: 'pcdn:jszip@3.8.0/dist/jszip.js',
'bootstrap.css': 'pcdn:bootstrap@3.3.7/dist/css/bootstrap.min.css',
css: 'pcdn:systemjs-plugin-css@0.1.37/css.js',
'plugin-babel': 'pcdn:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'pcdn:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js',
},
node_modules: {
defaultExtension: 'js',
},
},
});
})(this);

<template>
<div class="container-fluid">
<p>
This sample demonstrates the "Simple single grid export" scenario and shows how to export FlexGrid in
a background thread.
</p>
<button class="btn btn-default" :disabled="ctx1.preparing" @click="export1(ctx1)">{{ ctx1.exporting ? 'Cancel' :
'Export' }}</button>
<span>{{ (ctx1.progress * 100).toFixed(1) + "%" }}</span>
<wj-flex-grid class="grid" :autoGenerateColumns=false headersVisibility="Column" allowMerging="All"
:itemsSource="data" :isDisabled="ctx1.preparing" :initialized="initializeGrid">
<wj-flex-grid-column header="ID" binding="id"></wj-flex-grid-column>
<wj-flex-grid-column header="Start Date" binding="start" format="d"></wj-flex-grid-column>
<wj-flex-grid-column header="End Date" binding="end" format="d"></wj-flex-grid-column>
<wj-flex-grid-column header="Country" binding="country"></wj-flex-grid-column>
<wj-flex-grid-column header="Product" binding="product"></wj-flex-grid-column>
<wj-flex-grid-column header="Amount" binding="amount" format="c"></wj-flex-grid-column>
<wj-flex-grid-column header="Color" binding="color"></wj-flex-grid-column>
<wj-flex-grid-column header="Pending" binding="amount2" format="c2"></wj-flex-grid-column>
<wj-flex-grid-column header="Discount" binding="discount" format="p1"></wj-flex-grid-column>
<wj-flex-grid-column header="Active" binding="active"></wj-flex-grid-column>
</wj-flex-grid>
<hr />
<p>
This sample demonstrates the "Custom document generation" scenario and shows how to export FlexPie
(as a SVG image), FlexGrid and PNG image to a PDF in a background thread.
</p>
<p>
The <a href="https://www.npmjs.com/package/xmldom">xmldom</a> library is used here to bring DOM
support to the server to be able to draw SVG.
</p>
<button class="btn btn-default" :disabled="ctx2.preparing" @click="export2(ctx2)">{{ ctx2.exporting ? 'Cancel' :
'Export' }}</button>
<span>{{ (ctx2.progress * 100).toFixed(1) + "%" }}</span>
<p></p>
<div class="row">
<div class="col-md-6">
<wj-flex-pie :itemsSource="totals" binding="value" bindingName="name" :innerRadius="0.75"
:initialized="initializePie">
<wj-flex-pie-data-label content="{value:c1}" position="Inside"></wj-flex-pie-data-label>
</wj-flex-pie>
</div>
<div class="col-md-6">
<wj-flex-grid class="grid" :autoGenerateColumns=false headersVisibility="Column" allowMerging="All"
:itemsSource="data" :isDisabled="ctx2.preparing" :initialized="initializeGrid2">
<wj-flex-grid-column header="ID" binding="id"></wj-flex-grid-column>
<wj-flex-grid-column header="Start Date" binding="start" format="d"></wj-flex-grid-column>
<wj-flex-grid-column header="End Date" binding="end" format="d"></wj-flex-grid-column>
<wj-flex-grid-column header="Country" binding="country"></wj-flex-grid-column>
<wj-flex-grid-column header="Product" binding="product"></wj-flex-grid-column>
<wj-flex-grid-column header="Amount" binding="amount" format="c"></wj-flex-grid-column>
<wj-flex-grid-column header="Color" binding="color"></wj-flex-grid-column>
<wj-flex-grid-column header="Pending" binding="amount2" format="c2"></wj-flex-grid-column>
<wj-flex-grid-column header="Discount" binding="discount" format="p1"></wj-flex-grid-column>
<wj-flex-grid-column header="Active" binding="active"></wj-flex-grid-column>
</wj-flex-grid>
</div>
</div>
<hr />
<p>
This sample demonstrates the "Low-level usage of Web Workers API" scenario and shows how to export
FlexGrid to a PDF in a background thread using Web Workers API.
</p>
<button class="btn btn-default" :disabled="ctx3.preparing" @click="export3(ctx3)">{{ ctx3.exporting ? 'Cancel' :
'Export' }}</button>
<span>{{ (ctx3.progress * 100).toFixed(1) + "%" }}</span>
<wj-flex-grid class="grid" :autoGenerateColumns=false headersVisibility="Column" allowMerging="All"
:itemsSource="data" :isDisabled="ctx3.preparing" :initialized="initializeGrid3">
<wj-flex-grid-column header="ID" binding="id"></wj-flex-grid-column>
<wj-flex-grid-column header="Start Date" binding="start" format="d"></wj-flex-grid-column>
<wj-flex-grid-column header="End Date" binding="end" format="d"></wj-flex-grid-column>
<wj-flex-grid-column header="Country" binding="country"></wj-flex-grid-column>
<wj-flex-grid-column header="Product" binding="product"></wj-flex-grid-column>
<wj-flex-grid-column header="Amount" binding="amount" format="c"></wj-flex-grid-column>
<wj-flex-grid-column header="Color" binding="color"></wj-flex-grid-column>
<wj-flex-grid-column header="Pending" binding="amount2" format="c2"></wj-flex-grid-column>
<wj-flex-grid-column header="Discount" binding="discount" format="p1"></wj-flex-grid-column>
<wj-flex-grid-column header="Active" binding="active"></wj-flex-grid-column>
</wj-flex-grid>
</div>
</template>
<script setup>
import * as chart from "@mescius/wijmo.chart";
import "@mescius/wijmo.chart.render";
import * as pdf from "@mescius/wijmo.pdf";
import * as gridPdf from "@mescius/wijmo.grid.pdf";
import { getExpenses, getData } from "./data";
import { ref } from "vue";
const docName = ref("FlexGrid.pdf");
const gridExportSettings = ref({
styles: {
cellStyle: {
backgroundColor: "#ffffff",
borderColor: "#c6c6c6",
},
altCellStyle: {
backgroundColor: "#f9f9f9",
},
groupCellStyle: {
backgroundColor: "#dddddd",
},
headerCellStyle: {
backgroundColor: "#eaeaea",
},
},
});
const data = ref(getData(1500));
const totals = ref(
((totals) => [
{ name: "Hotel", value: totals.hotel },
{ name: "Transport", value: totals.transport },
{ name: "Meal", value: totals.meal },
{ name: "Fuel", value: totals.fuel },
{ name: "Misc", value: totals.Misc },
])(getExpenses().totals),
);
const ctx1 = ref({
exporting: false,
progress: 0,
preparing: false,
worker: null,
});
const ctx2 = ref({
exporting: false,
progress: 0,
preparing: false,
worker: null,
});
const ctx3 = ref({
exporting: false,
progress: 0,
preparing: false,
worker: null,
});
const flexGrid = ref(null);
const flexGrid2 = ref(null);
const flexGrid3 = ref(null);
const flexPie = ref(null);
function initializeGrid(ctl) {
flexGrid.value = ctl;
}
function initializeGrid2(ctl) {
flexGrid2.value = ctl;
}
function initializeGrid3(ctl) {
flexGrid3.value = ctl;
}
function initializePie(ctl) {
flexPie.value = ctl;
}
function export1(ctx) {
if (!ctx.exporting) {
start(ctx, "./export-grid.js", () => {
gridPdf.PdfWebWorkerClient.exportGrid(ctx.worker, flexGrid.value, docName.value, gridExportSettings.value, null, (_progress) => {
progress(ctx, _progress);
});
});
} else {
cancel(ctx);
}
}
function export2(ctx) {
if (!ctx.exporting) {
start(ctx, "./export.js", () => {
gridPdf.PdfWebWorkerClient.addString(ctx.worker, "Title", "title");
gridPdf.PdfWebWorkerClient.addImage(ctx.worker, "resources/canada.png", "flag", null);
flexPie.value.saveImageToDataUrl(chart.ImageFormat.Svg, (url) => {
gridPdf.PdfWebWorkerClient.addImage(ctx.worker, url, "chart", null);
});
gridPdf.PdfWebWorkerClient.addGrid(ctx.worker, flexGrid2.value, "grid", gridExportSettings.value);
//
gridPdf.PdfWebWorkerClient.export(
ctx.worker,
null,
(data) => pdf.saveBlob(data.blob, docName.value),
(_progress) => progress(ctx, _progress),
);
});
} else {
cancel(ctx);
}
}
function export3(ctx) {
if (!ctx.exporting) {
start(ctx, "./api.js", () => {
ctx.worker.addEventListener("message", (e) => {
if (e.data.type === "progress") {
progress(ctx, e.data.value);
} else {
pdf.saveBlob(new Blob([new Uint8Array(e.data.data)], { type: "application/pdf" }), docName.value);
}
});
//
var gridData = gridPdf.PdfWebWorkerClient.serializeGrid(flexGrid3.value, gridExportSettings.value);
// Send gridData as a tranferable object
ctx.worker.postMessage({ grid: gridData, settings: JSON.stringify(gridExportSettings.value) }, [gridData]);
});
} else {
cancel(ctx);
}
}
/**
* Creates web worker that executes the module from the specified URL.
* @param url The module URL, relative to the src/workers directory.
* @param ready
*/
function loadWorker(url, ready) {
let worker = new Worker("src/workers/worker-loader.js");
//
worker.addEventListener("message", (e) => {
if (e.data === "#ready#") {
ready();
}
});
//
worker.postMessage({ url: url });
//
return worker;
}
function start(ctx, url, ready) {
ctx.preparing = true;
ctx.progress = 0;
ctx.worker = loadWorker(url, () => ready());
}
function progress(ctx, _progress) {
if (_progress === 0 || _progress === 1) {
ctx.preparing = false;
ctx.exporting = _progress === 0;
}
ctx.progress = _progress;
}
function cancel(ctx) {
ctx.worker.terminate();
ctx.exporting = false;
ctx.progress = 0;
ctx.worker = null;
}
</script>
<style>
body {
margin-bottom: 24px;
}
.grid {
margin-top: 20px;
height: 300px;
}
</style>
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>Web Workers</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="compiler.js" type="module"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.21.5/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app.js');
</script>
</head>
<body>
<div id="app">
</div>
</body>
</html>
export function getData(count) {
// data used to generate random items
const countries = ['US', 'Germany', 'UK', 'Japan', 'Italy', 'Greece'];
const products = ['Widget', 'Gadget', 'Doohickey'];
const colors = ['Orange', 'White', 'Red', 'Green', 'Blue'];
//
let data = [];
let dt = new Date();
//
// add count items
for (let i = 0; i < count; i++) {
// constants used to create data items
let date = new Date(dt.getFullYear(), i % 12, 25, i % 24, i % 60, i % 60),
countryId = Math.floor(Math.random() * countries.length),
productId = Math.floor(Math.random() * products.length),
colorId = Math.floor(Math.random() * colors.length);
//
// create the item
let item = {
id: i,
start: date,
end: date,
country: countries[countryId],
product: products[productId],
color: colors[colorId],
amount: Math.random() * 10000 - 5000,
amount2: Math.random() * 10000 - 5000,
discount: Math.random() / 4,
active: i % 4 == 0,
};
//
// add the item to the list
data.push(item);
}
return data;
}
export function getExpenses() {
// [5; 10]
let count = 5 + Math.round(Math.random() * 5),
ret = {
items: [],
totals: { hotel: 0, transport: 0, fuel: 0, meal: 0, Misc: 0, total: 0 }
},
msPerDay = 1000 * 24 * 60 * 60,
curDate = Date.now() - 60 * msPerDay;
//
for (let i = 0; i < count; i++) {
let item = {
date: new Date(curDate),
description: 'Customer visit',
hotel: 30 + Math.random() * 200,
transport: 10 + Math.random() * 150,
fuel: Math.random() * 50,
meal: 30 + Math.random() * 170,
Misc: Math.random() * 220,
total: 0
};
//
item.total = item.hotel + item.transport + item.fuel + item.meal + item.Misc;
//
ret.totals.fuel += item.fuel;
ret.totals.hotel += item.hotel;
ret.totals.meal += item.meal;
ret.totals.Misc += item.Misc;
ret.totals.total += item.total;
ret.totals.transport += item.transport;
//
ret.items.push(item);
//
curDate += msPerDay * Math.round(Math.random() * 4);
}
//
return ret;
}
import { PdfWebWorker } from '@mescius/wijmo.grid.pdf';
//
PdfWebWorker.initExportGrid();
import xmldom from 'xmldom';
import * as gridPdf from '@mescius/wijmo.grid.pdf';
//
self.DOMParser = xmldom.DOMParser;
//
gridPdf.PdfWebWorker.initExport((doc, clientData) => {
gridPdf.PdfWebWorker.sendExportProgress(0);
//
doc.drawText(clientData['title'].content);
doc.drawImage(clientData['flag'].content);
doc.drawSvg(clientData['chart'].content);
//
// Suppose that text and images rendering takes 5% of the time.
gridPdf.PdfWebWorker.sendExportProgress(0.05);
//
let gridData = clientData['grid'];
gridData.settings.progress = (value) => {
// Change progress from 6% to 90%. Left the final 10% for the document finalization, which will start after the doc.end() method is called.
gridPdf.PdfWebWorker.sendExportProgress(map(value, 0, 1, 0.06, 0.9));
};
//
doc.ended.addHandler(() => {
// Document has been created, set progress to 100%.
gridPdf.PdfWebWorker.sendExportProgress(1);
});
//
gridPdf.FlexGridPdfConverter.draw(gridData.content, doc, null, null, gridData.settings);
//
doc.end();
});
//
function map(value, inMin, inMax, outMin, outMax) {
let k = (outMax - outMin) / (inMax - inMin);
return (value - inMin) * k + outMin;
}
import * as pdf from '@mescius/wijmo.pdf';
import * as gridPdf from '@mescius/wijmo.grid.pdf';
//
addEventListener('message', (e) => {
let json = e.data.grid, settings = JSON.parse(e.data.settings);
//
settings.documentOptions = settings.documentOptions || {};
//
settings.documentOptions.ended = (sender, args) => {
postProgress(1); // 100%
//
// Convert Blob to a transferable object...
let fileReader = new FileReader();
fileReader.onload = (e) => {
let buffer = e.target.result;
// ...and send it to client.
postMessage({ data: buffer }, [buffer]);
};
fileReader.readAsArrayBuffer(args.blob);
};
//
settings.progress = (value) => {
postProgress(value * 0.9); // 0% to 90%
};
//
let doc = new pdf.PdfDocument(settings.documentOptions), grid = gridPdf.PdfWebWorker.deserializeGrid(json, settings);
//
gridPdf.FlexGridPdfConverter.draw(grid, doc, null, null, settings);
//
doc.end();
});
//
function postProgress(value) {
postMessage({ type: 'progress', value: value });
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
meta: {
'*.css': { loader: 'css' },
'*.vue': { loader: '../plugin-vue/index.js' }
//'*.vue': { loader: 'systemjs-plugin-vue' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.vue2.chart.analytics": "npm:@mescius/wijmo.vue2.chart.analytics/index.js",
"@mescius/wijmo.vue2.chart.animation": "npm:@mescius/wijmo.vue2.chart.animation/index.js",
"@mescius/wijmo.vue2.chart.annotation": "npm:@mescius/wijmo.vue2.chart.annotation/index.js",
"@mescius/wijmo.vue2.chart.finance.analytics": "npm:@mescius/wijmo.vue2.chart.finance.analytics/index.js",
"@mescius/wijmo.vue2.chart.finance": "npm:@mescius/wijmo.vue2.chart.finance/index.js",
"@mescius/wijmo.vue2.chart.hierarchical": "npm:@mescius/wijmo.vue2.chart.hierarchical/index.js",
"@mescius/wijmo.vue2.chart.interaction": "npm:@mescius/wijmo.vue2.chart.interaction/index.js",
"@mescius/wijmo.vue2.chart.radar": "npm:@mescius/wijmo.vue2.chart.radar/index.js",
'@mescius/wijmo.vue2.chart.map': 'npm:@mescius/wijmo.vue2.chart.map/index.js',
"@mescius/wijmo.vue2.chart": "npm:@mescius/wijmo.vue2.chart/index.js",
"@mescius/wijmo.vue2.core": "npm:@mescius/wijmo.vue2.core/index.js",
"@mescius/wijmo.vue2.gauge": "npm:@mescius/wijmo.vue2.gauge/index.js",
"@mescius/wijmo.vue2.grid.detail": "npm:@mescius/wijmo.vue2.grid.detail/index.js",
"@mescius/wijmo.vue2.grid.filter": "npm:@mescius/wijmo.vue2.grid.filter/index.js",
"@mescius/wijmo.vue2.grid.grouppanel": "npm:@mescius/wijmo.vue2.grid.grouppanel/index.js",
'@mescius/wijmo.vue2.grid.search': 'npm:@mescius/wijmo.vue2.grid.search/index.js',
"@mescius/wijmo.vue2.grid.multirow": "npm:@mescius/wijmo.vue2.grid.multirow/index.js",
"@mescius/wijmo.vue2.grid.sheet": "npm:@mescius/wijmo.vue2.grid.sheet/index.js",
'@mescius/wijmo.vue2.grid.transposed': 'npm:@mescius/wijmo.vue2.grid.transposed/index.js',
'@mescius/wijmo.vue2.grid.transposedmultirow': 'npm:@mescius/wijmo.vue2.grid.transposedmultirow/index.js',
"@mescius/wijmo.vue2.grid": "npm:@mescius/wijmo.vue2.grid/index.js",
"@mescius/wijmo.vue2.input": "npm:@mescius/wijmo.vue2.input/index.js",
"@mescius/wijmo.vue2.olap": "npm:@mescius/wijmo.vue2.olap/index.js",
"@mescius/wijmo.vue2.viewer": "npm:@mescius/wijmo.vue2.viewer/index.js",
"@mescius/wijmo.vue2.nav": "npm:@mescius/wijmo.vue2.nav/index.js",
"@mescius/wijmo.vue2.base": "npm:@mescius/wijmo.vue2.base/index.js",
'@mescius/wijmo.vue2.barcode.common': 'npm:@mescius/wijmo.vue2.barcode.common/index.js',
'@mescius/wijmo.vue2.barcode.composite': 'npm:@mescius/wijmo.vue2.barcode.composite/index.js',
'@mescius/wijmo.vue2.barcode.specialized': 'npm:@mescius/wijmo.vue2.barcode.specialized/index.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'jszip': 'npm:jszip/dist/jszip.js',
'css': 'npm:systemjs-plugin-css/css.js',
'vue': 'npm:vue/dist/vue.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'vue-loader': 'npm:systemjs-vue-browser/index.js',
//'systemjs-plugin-vue': 'npm:systemjs-plugin-vue/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'xmldom': 'npm:xmldom/lib/dom-parser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
wijmo: {
defaultExtension: 'js',
}
}
});
})(this);

This sample demonstrates how to use Web Workers to export FlexGrid to a PDF or generate a custom PDF in a background thread.
Learn about FlexGrid | FlexGrid API Reference
This example uses React.
import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import ReactDOM from 'react-dom/client';
import React, { useEffect, useRef, useState } from 'react';
import useEvent from 'react-use-event-hook';
import * as chart from '@mescius/wijmo.chart';
import * as pdf from '@mescius/wijmo.pdf';
import * as gridPdf from '@mescius/wijmo.grid.pdf';
import '@mescius/wijmo.chart.render';
import * as wjcGrid from '@mescius/wijmo.react.grid';
import * as WjChartModule from '@mescius/wijmo.react.chart';
import './app.css';
import { expenses, data } from './data';
const docName = 'FlexGrid.pdf';
const totals = ((totals) => [
{ name: 'Hotel', value: totals.hotel },
{ name: 'Transport', value: totals.transport },
{ name: 'Meal', value: totals.meal },
{ name: 'Fuel', value: totals.fuel },
{ name: 'Misc', value: totals.Misc }
])(expenses.totals);
const gridExportSettings = {
styles: {
cellStyle: {
backgroundColor: '#ffffff',
borderColor: '#c6c6c6'
},
altCellStyle: {
backgroundColor: '#f9f9f9'
},
groupCellStyle: {
backgroundColor: '#dddddd'
},
headerCellStyle: {
backgroundColor: '#eaeaea'
}
}
};
function App() {
const [count, setCount] = useState(0);
const ctx1 = useRef({
exporting: false,
progress: 0,
preparing: false,
worker: null
});
const ctx2 = useRef({
exporting: false,
progress: 0,
preparing: false,
worker: null
});
const ctx3 = useRef({
exporting: false,
progress: 0,
preparing: false,
worker: null
});
const grid1Ref = useRef();
const grid2Ref = useRef();
const grid3Ref = useRef();
const pieRef = useRef();
const forceUpdate = () => setCount(Math.random());
const initializeGrid = useEvent((source) => {
grid1Ref.current = source;
});
const initializeGrid2 = useEvent((source) => {
grid2Ref.current = source;
});
const initializeGrid3 = useEvent((source) => {
grid3Ref.current = source;
});
const initializePie = useEvent((source) => {
pieRef.current = source;
});
const export1 = () => {
const ctx = ctx1.current;
if (!ctx.exporting) {
start(ctx, './export-grid', () => {
if (ctx.worker && grid1Ref.current) {
gridPdf.PdfWebWorkerClient.exportGrid(ctx.worker, grid1Ref.current, docName, gridExportSettings, undefined, (prog) => {
progress(ctx, prog);
});
}
});
}
else {
cancel(ctx);
}
};
const export2 = () => {
const ctx = ctx2.current;
if (!ctx.exporting) {
start(ctx, './export', () => {
if (ctx.worker) {
gridPdf.PdfWebWorkerClient.addString(ctx.worker, 'Title', 'title');
gridPdf.PdfWebWorkerClient.addImage(ctx.worker, 'resources/canada.png', 'flag');
pieRef.current.saveImageToDataUrl(chart.ImageFormat.Svg, (url) => {
if (ctx.worker) {
gridPdf.PdfWebWorkerClient.addImage(ctx.worker, url, 'chart');
}
});
if (grid2Ref.current) {
gridPdf.PdfWebWorkerClient.addGrid(ctx.worker, grid2Ref.current, 'grid', gridExportSettings);
}
gridPdf.PdfWebWorkerClient.export(ctx.worker, null, (data) => pdf.saveBlob(data.blob, docName), (prog) => progress(ctx, prog));
}
});
}
else {
cancel(ctx);
}
};
const export3 = () => {
const ctx = ctx3.current;
if (!ctx.exporting) {
start(ctx, './api', () => {
if (ctx.worker) {
ctx.worker.addEventListener('message', e => {
if (e.data.type === 'progress') {
progress(ctx, e.data.value);
}
else {
pdf.saveBlob(new Blob([new Uint8Array(e.data.data)], { type: 'application/pdf' }), docName);
}
});
if (grid3Ref.current) {
let gridData = gridPdf.PdfWebWorkerClient.serializeGrid(grid3Ref.current, gridExportSettings);
// Send gridData as a tranferable object
ctx.worker.postMessage({ grid: gridData, settings: JSON.stringify(gridExportSettings) }, [gridData]);
}
}
});
}
else {
cancel(ctx);
}
};
/**
* Creates web worker that executes the module from the specified URL.
* @param url The module URL, relative to the src/workers directory.
* @param ready
*/
const loadWorker = (url, ready) => {
let worker = new Worker('src/workers/worker-loader.js');
worker.addEventListener('message', (e) => {
if (e.data === '#ready#') {
ready();
}
});
worker.postMessage({ url: url });
return worker;
};
const start = (ctx, url, ready) => {
ctx.preparing = true;
ctx.progress = 0;
ctx.worker = loadWorker(url, () => ready());
forceUpdate();
};
const progress = (ctx, progress) => {
if (progress === 0 || progress === 1) {
ctx.preparing = false;
ctx.exporting = progress === 0;
ctx.progress = progress;
}
else {
ctx.progress = progress;
}
forceUpdate();
};
const cancel = (ctx) => {
if (ctx.worker) {
ctx.worker.terminate();
}
ctx.exporting = false;
ctx.progress = 0;
ctx.worker = null;
forceUpdate();
};
useEffect(() => {
return function cleanup() {
if (ctx1.current.worker) {
ctx1.current.worker.terminate();
ctx1.current.worker = null;
}
if (ctx2.current.worker) {
ctx2.current.worker.terminate();
ctx2.current.worker = null;
}
if (ctx3.current.worker) {
ctx3.current.worker.terminate();
ctx3.current.worker = null;
}
};
}, []);
return (<div className="container-fluid">
<p>
This sample demonstrates the "Simple single grid export" scenario and shows how to export FlexGrid in
a background thread.
</p>
<button className="btn btn-default" disabled={ctx1.current.preparing} onClick={export1}>{ctx1.current.exporting ? 'Cancel' : 'Export'}</button>
<span>{(ctx1.current.progress * 100).toFixed(1) + "%"}</span>
<wjcGrid.FlexGrid className="grid" autoGenerateColumns={false} headersVisibility="Column" allowMerging="All" itemsSource={data} isDisabled={ctx1.current.preparing} initialized={initializeGrid}>
<wjcGrid.FlexGridColumn header="ID" binding="id"></wjcGrid.FlexGridColumn>
<wjcGrid.FlexGridColumn header="Start Date" binding="start" format="d"></wjcGrid.FlexGridColumn>
<wjcGrid.FlexGridColumn header="End Date" binding="end" format="d"></wjcGrid.FlexGridColumn>
<wjcGrid.FlexGridColumn header="Country" binding="country"></wjcGrid.FlexGridColumn>
<wjcGrid.FlexGridColumn header="Product" binding="product"></wjcGrid.FlexGridColumn>
<wjcGrid.FlexGridColumn header="Amount" binding="amount" format="c"></wjcGrid.FlexGridColumn>
<wjcGrid.FlexGridColumn header="Color" binding="color"></wjcGrid.FlexGridColumn>
<wjcGrid.FlexGridColumn header="Pending" binding="amount2" format="c2"></wjcGrid.FlexGridColumn>
<wjcGrid.FlexGridColumn header="Discount" binding="discount" format="p1"></wjcGrid.FlexGridColumn>
<wjcGrid.FlexGridColumn header="Active" binding="active"></wjcGrid.FlexGridColumn>
</wjcGrid.FlexGrid>
<hr />
<p>
This sample demonstrates the "Custom document generation" scenario and shows how to export FlexPie
(as a SVG image), FlexGrid and PNG image to a PDF in a background thread.
</p>
<p>
The <a href="https://www.npmjs.com/package/xmldom">xmldom</a> library is used here to bring DOM
support to the server to be able to draw SVG.
</p>
<button className="btn btn-default" disabled={ctx2.current.preparing} onClick={export2}>{ctx2.current.exporting ? 'Cancel' : 'Export'}</button>
<span>{(ctx2.current.progress * 100).toFixed(1) + "%"}</span>
<p></p>
<div className="row">
<div className="col-md-6">
<WjChartModule.FlexPie itemsSource={totals} binding="value" bindingName="name" innerRadius={0.75} initialized={initializePie}>
<WjChartModule.FlexPieDataLabel content="{value:c1}" position="Inside"></WjChartModule.FlexPieDataLabel>
</WjChartModule.FlexPie>
</div>
<div className="col-md-6">
<wjcGrid.FlexGrid className="grid" autoGenerateColumns={false} headersVisibility="Column" allowMerging="All" itemsSource={data} isDisabled={ctx2.current.preparing} initialized={initializeGrid2}>
<wjcGrid.FlexGridColumn header="ID" binding="id"></wjcGrid.FlexGridColumn>
<wjcGrid.FlexGridColumn header="Start Date" binding="start" format="d"></wjcGrid.FlexGridColumn>
<wjcGrid.FlexGridColumn header="End Date" binding="end" format="d"></wjcGrid.FlexGridColumn>
<wjcGrid.FlexGridColumn header="Country" binding="country"></wjcGrid.FlexGridColumn>
<wjcGrid.FlexGridColumn header="Product" binding="product"></wjcGrid.FlexGridColumn>
<wjcGrid.FlexGridColumn header="Amount" binding="amount" format="c"></wjcGrid.FlexGridColumn>
<wjcGrid.FlexGridColumn header="Color" binding="color"></wjcGrid.FlexGridColumn>
<wjcGrid.FlexGridColumn header="Pending" binding="amount2" format="c2"></wjcGrid.FlexGridColumn>
<wjcGrid.FlexGridColumn header="Discount" binding="discount" format="p1"></wjcGrid.FlexGridColumn>
<wjcGrid.FlexGridColumn header="Active" binding="active"></wjcGrid.FlexGridColumn>
</wjcGrid.FlexGrid>
</div>
</div>
<hr />
<p>
This sample demonstrates the "Low-level usage of Web Workers API" scenario and shows how to export
FlexGrid to a PDF in a background thread using Web Workers API.
</p>
<button className="btn btn-default" disabled={ctx3.current.preparing} onClick={export3}>{ctx3.current.exporting ? 'Cancel' :
'Export'}</button>
<span>{(ctx3.current.progress * 100).toFixed(1) + "%"}</span>
<p></p>
<wjcGrid.FlexGrid className="grid" autoGenerateColumns={false} headersVisibility="Column" allowMerging="All" itemsSource={data} isDisabled={ctx3.current.preparing} initialized={initializeGrid3}>
<wjcGrid.FlexGridColumn header="ID" binding="id"></wjcGrid.FlexGridColumn>
<wjcGrid.FlexGridColumn header="Start Date" binding="start" format="d"></wjcGrid.FlexGridColumn>
<wjcGrid.FlexGridColumn header="End Date" binding="end" format="d"></wjcGrid.FlexGridColumn>
<wjcGrid.FlexGridColumn header="Country" binding="country"></wjcGrid.FlexGridColumn>
<wjcGrid.FlexGridColumn header="Product" binding="product"></wjcGrid.FlexGridColumn>
<wjcGrid.FlexGridColumn header="Amount" binding="amount" format="c"></wjcGrid.FlexGridColumn>
<wjcGrid.FlexGridColumn header="Color" binding="color"></wjcGrid.FlexGridColumn>
<wjcGrid.FlexGridColumn header="Pending" binding="amount2" format="c2"></wjcGrid.FlexGridColumn>
<wjcGrid.FlexGridColumn header="Discount" binding="discount" format="p1"></wjcGrid.FlexGridColumn>
<wjcGrid.FlexGridColumn header="Active" binding="active"></wjcGrid.FlexGridColumn>
</wjcGrid.FlexGrid>
</div>);
}
const container = document.getElementById('app');
if (container) {
const root = ReactDOM.createRoot(container);
root.render(<App />);
}
Submit and view feedback for

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import './styles.css';
//
import * as chart from '@mescius/wijmo.chart';
import '@mescius/wijmo.chart.render';
import * as grid from '@mescius/wijmo.grid';
import * as pdf from '@mescius/wijmo.pdf';
import * as gridPdf from '@mescius/wijmo.grid.pdf';
//
import '@angular/compiler';
import { Component, Inject, enableProdMode, OnDestroy, ViewChild, ɵresolveComponentResources } from '@angular/core';
import { BrowserModule, bootstrapApplication } from '@angular/platform-browser';
import { IExpense, DataService } from './app.data';
import { WjGridModule } from '@mescius/wijmo.angular2.grid';
import { WjChartModule } from '@mescius/wijmo.angular2.chart';
//
interface IContext {
exporting: boolean;
progress: number;
preparing: boolean;
worker: Worker;
}
//
@Component({
standalone: true,
providers: [DataService],
imports: [WjGridModule, WjChartModule, BrowserModule],
selector: 'app-component',
templateUrl: 'src/app.component.html',
})
export class AppComponent implements OnDestroy {
private readonly docName = 'FlexGrid.pdf';
private readonly gridExportSettings: gridPdf.IFlexGridExportSettings = {
styles: {
cellStyle: {
backgroundColor: '#ffffff',
borderColor: '#c6c6c6',
},
altCellStyle: {
backgroundColor: '#f9f9f9',
},
groupCellStyle: {
backgroundColor: '#dddddd',
},
headerCellStyle: {
backgroundColor: '#eaeaea',
},
},
};
//
data: any[];
totals: any;
//
constructor(@Inject(DataService) private dataService: DataService) {
this.data = dataService.getData(1500);
//
this.totals = ((totals: IExpense) => [
{ name: 'Hotel', value: totals.hotel },
{ name: 'Transport', value: totals.transport },
{ name: 'Meal', value: totals.meal },
{ name: 'Fuel', value: totals.fuel },
{ name: 'Misc', value: totals.Misc },
])(dataService.getExpenses().totals);
}
//
//
@ViewChild('flexGrid', { static: true }) flexGrid: grid.FlexGrid;
ctx1: IContext = {
exporting: false,
progress: 0,
preparing: false,
worker: null,
};
//
export1(ctx: IContext) {
if (!ctx.exporting) {
this.start(ctx, './export-grid', () => {
gridPdf.PdfWebWorkerClient.exportGrid(
ctx.worker,
this.flexGrid,
this.docName,
this.gridExportSettings,
null,
(progress: number) => {
this.progress(ctx, progress);
},
);
});
} else {
this.cancel(ctx);
}
}
//
//
@ViewChild('flexGrid2', { static: true }) flexGrid2: grid.FlexGrid;
@ViewChild('flexPie', { static: true }) flexPie: chart.FlexPie;
ctx2: IContext = {
exporting: false,
progress: 0,
preparing: false,
worker: null,
};
//
export2(ctx: IContext) {
if (!ctx.exporting) {
this.start(ctx, './export', () => {
gridPdf.PdfWebWorkerClient.addString(ctx.worker, 'Title', 'title');
gridPdf.PdfWebWorkerClient.addImage(ctx.worker, 'resources/canada.png', 'flag', null);
this.flexPie.saveImageToDataUrl(chart.ImageFormat.Svg, (url: string) => {
gridPdf.PdfWebWorkerClient.addImage(ctx.worker, url, 'chart', null);
});
gridPdf.PdfWebWorkerClient.addGrid(ctx.worker, this.flexGrid2, 'grid', this.gridExportSettings);
//
gridPdf.PdfWebWorkerClient.export(
ctx.worker,
null,
(data: gridPdf.PdfWebWorkerExportDoneEventArgs) => pdf.saveBlob(data.blob, this.docName),
(progress: number) => this.progress(ctx, progress),
);
});
} else {
this.cancel(ctx);
}
}
//
//
@ViewChild('flexGrid3', { static: true }) flexGrid3: grid.FlexGrid;
ctx3: IContext = {
exporting: false,
progress: 0,
preparing: false,
worker: null,
};
//
export3(ctx: IContext) {
if (!ctx.exporting) {
this.start(ctx, './api', () => {
ctx.worker.addEventListener('message', (e) => {
if (e.data.type === 'progress') {
this.progress(ctx, e.data.value);
} else {
pdf.saveBlob(new Blob([new Uint8Array(e.data.data)], { type: 'application/pdf' }), this.docName);
}
});
//
var gridData = gridPdf.PdfWebWorkerClient.serializeGrid(this.flexGrid3, this.gridExportSettings);
// Send gridData as a tranferable object
ctx.worker.postMessage({ grid: gridData, settings: JSON.stringify(this.gridExportSettings) }, [gridData]);
});
} else {
this.cancel(ctx);
}
}
//
/**
* Creates web worker that executes the module from the specified URL.
* @param url The module URL, relative to the src/workers directory.
* @param ready
*/
private loadWorker(url: string, ready: Function) {
let worker = new Worker('src/workers/worker-loader.js');
//
worker.addEventListener('message', (e) => {
if (e.data === '#ready#') {
ready();
}
});
//
worker.postMessage({ url: url });
//
return worker;
}
//
private start(ctx: IContext, url: string, ready: Function) {
ctx.preparing = true;
ctx.progress = 0;
ctx.worker = this.loadWorker(url, () => ready());
}
//
private progress(ctx: IContext, progress: number) {
if (progress === 0 || progress === 1) {
ctx.preparing = false;
ctx.exporting = progress === 0;
}
ctx.progress = progress;
}
//
private cancel(ctx: IContext) {
ctx.worker.terminate();
ctx.exporting = false;
ctx.progress = 0;
ctx.worker = null;
}
//
ngOnDestroy() {
if (this.ctx1.worker) {
this.ctx1.worker.terminate();
this.ctx1.worker = null;
}
//
if (this.ctx2.worker) {
this.ctx2.worker.terminate();
this.ctx2.worker = null;
}
//
if (this.ctx3.worker) {
this.ctx3.worker.terminate();
this.ctx3.worker = null;
}
}
}
//
//
enableProdMode();
// Resolve resources (templateUrl, styleUrls etc), After resolution all URLs have been converted into `template` strings.
ɵresolveComponentResources(fetch).then(() => {
// Bootstrap application
bootstrapApplication(AppComponent).catch((err) => console.error(err));
});
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>Web Workers</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- Polyfills -->
<script src="node_modules/core-js/client/shim.min.js"></script>
<script src="node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.21.5/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="container-fluid">
<p>
This sample demonstrates the "Simple single grid export" scenario and shows how to export FlexGrid in
a background thread.
</p>
<button class="btn btn-default" [disabled]="ctx1.preparing" (click)="export1(ctx1)">{{ctx1.exporting ? 'Cancel' :
'Export'}}</button>
<span>{{ ctx1.progress | percent:'1.1-1' }}</span>
<wj-flex-grid class="grid" #flexGrid [autoGenerateColumns]="false" headersVisibility="Column" allowMerging="All"
[itemsSource]="data" [isDisabled]="ctx1.preparing">
<wj-flex-grid-column header="ID" binding="id"></wj-flex-grid-column>
<wj-flex-grid-column header="Start Date" binding="start" format="d"></wj-flex-grid-column>
<wj-flex-grid-column header="End Date" binding="end" format="d"></wj-flex-grid-column>
<wj-flex-grid-column header="Country" binding="country"></wj-flex-grid-column>
<wj-flex-grid-column header="Product" binding="product"></wj-flex-grid-column>
<wj-flex-grid-column header="Amount" binding="amount" format="c"></wj-flex-grid-column>
<wj-flex-grid-column header="Color" binding="color"></wj-flex-grid-column>
<wj-flex-grid-column header="Pending" binding="amount2" format="c2"></wj-flex-grid-column>
<wj-flex-grid-column header="Discount" binding="discount" format="p1"></wj-flex-grid-column>
<wj-flex-grid-column header="Active" binding="active"></wj-flex-grid-column>
</wj-flex-grid>
<hr />
<p>
This sample demonstrates the "Custom document generation" scenario and shows how to export FlexPie
(as a SVG image), FlexGrid and PNG image to a PDF in a background thread.
</p>
<p>
The <a href="https://www.npmjs.com/package/xmldom">xmldom</a> library is used here to bring DOM
support to the server to be able to draw SVG.
</p>
<button class="btn btn-default" [disabled]="ctx2.preparing" (click)="export2(ctx2)">{{ctx2.exporting ? 'Cancel' :
'Export'}}</button>
<span>{{ ctx2.progress | percent:'1.1-1' }}</span>
<p></p>
<div class="row">
<div class="col-md-6">
<wj-flex-pie #flexPie [itemsSource]="totals" binding="value" bindingName="name" [innerRadius]="0.75">
<wj-flex-pie-data-label content="{value:c1}" position="Inside"></wj-flex-pie-data-label>
</wj-flex-pie>
</div>
<div class="col-md-6">
<wj-flex-grid class="grid" #flexGrid2 [autoGenerateColumns]="false" headersVisibility="Column" allowMerging="All"
[itemsSource]="data" [isDisabled]="ctx2.preparing">
<wj-flex-grid-column header="ID" binding="id"></wj-flex-grid-column>
<wj-flex-grid-column header="Start Date" binding="start" format="d"></wj-flex-grid-column>
<wj-flex-grid-column header="End Date" binding="end" format="d"></wj-flex-grid-column>
<wj-flex-grid-column header="Country" binding="country"></wj-flex-grid-column>
<wj-flex-grid-column header="Product" binding="product"></wj-flex-grid-column>
<wj-flex-grid-column header="Amount" binding="amount" format="c"></wj-flex-grid-column>
<wj-flex-grid-column header="Color" binding="color"></wj-flex-grid-column>
<wj-flex-grid-column header="Pending" binding="amount2" format="c2"></wj-flex-grid-column>
<wj-flex-grid-column header="Discount" binding="discount" format="p1"></wj-flex-grid-column>
<wj-flex-grid-column header="Active" binding="active"></wj-flex-grid-column>
</wj-flex-grid>
</div>
</div>
<hr />
<p>
This sample demonstrates the "Low-level usage of Web Workers API" scenario and shows how to export
FlexGrid to a PDF in a background thread using Web Workers API.
</p>
<button class="btn btn-default" [disabled]="ctx3.preparing" (click)="export3(ctx3)">{{ctx3.exporting ? 'Cancel' :
'Export'}}</button>
<span>{{ ctx3.progress | percent:'1.1-1' }}</span>
<wj-flex-grid class="grid" #flexGrid3 [autoGenerateColumns]="false" headersVisibility="Column" allowMerging="All"
[itemsSource]="data" [isDisabled]="ctx3.preparing">
<wj-flex-grid-column header="ID" binding="id"></wj-flex-grid-column>
<wj-flex-grid-column header="Start Date" binding="start" format="d"></wj-flex-grid-column>
<wj-flex-grid-column header="End Date" binding="end" format="d"></wj-flex-grid-column>
<wj-flex-grid-column header="Country" binding="country"></wj-flex-grid-column>
<wj-flex-grid-column header="Product" binding="product"></wj-flex-grid-column>
<wj-flex-grid-column header="Amount" binding="amount" format="c"></wj-flex-grid-column>
<wj-flex-grid-column header="Color" binding="color"></wj-flex-grid-column>
<wj-flex-grid-column header="Pending" binding="amount2" format="c2"></wj-flex-grid-column>
<wj-flex-grid-column header="Discount" binding="discount" format="p1"></wj-flex-grid-column>
<wj-flex-grid-column header="Active" binding="active"></wj-flex-grid-column>
</wj-flex-grid>
</div>
import { Injectable } from '@angular/core';
//
export interface IExpense {
hotel: number;
transport: number;
fuel: number;
meal: number;
Misc: number;
total: number;
}
//
export interface IExpenseDetails extends IExpense {
date: Date;
description: string;
}
//
export interface IExpenses {
items: IExpenseDetails[];
totals: IExpense;
}
//
@Injectable()
export class DataService {
getData(count: number) {
// data used to generate random items
const countries = ['US', 'Germany', 'UK', 'Japan', 'Italy', 'Greece'];
const products = ['Widget', 'Gadget', 'Doohickey'];
const colors = ['Orange', 'White', 'Red', 'Green', 'Blue'];
//
let data = [];
let dt = new Date();
//
// add count items
for (let i = 0; i < count; i++) {
// constants used to create data items
let date = new Date(dt.getFullYear(), i % 12, 25, i % 24, i % 60, i % 60),
countryId = Math.floor(Math.random() * countries.length),
productId = Math.floor(Math.random() * products.length),
colorId = Math.floor(Math.random() * colors.length);
//
// create the item
let item = {
id: i,
start: date,
end: date,
country: countries[countryId],
product: products[productId],
color: colors[colorId],
amount: Math.random() * 10000 - 5000,
amount2: Math.random() * 10000 - 5000,
discount: Math.random() / 4,
active: i % 4 == 0,
};
//
// add the item to the list
data.push(item);
}
return data;
}
//
getExpenses(): IExpenses {
// [5; 10]
let count = 5 + Math.round(Math.random() * 5),
ret: IExpenses = {
items: [],
totals: { hotel: 0, transport: 0, fuel: 0, meal: 0, Misc: 0, total: 0 }
},
msPerDay = 1000 * 24 * 60 * 60,
curDate = Date.now() - 60 * msPerDay;
//
for (let i = 0; i < count; i++) {
let item: IExpenseDetails = {
date: new Date(curDate),
description: 'Customer visit',
hotel: 30 + Math.random() * 200,
transport: 10 + Math.random() * 150,
fuel: Math.random() * 50,
meal: 30 + Math.random() * 170,
Misc: Math.random() * 220,
total: 0
};
//
item.total = item.hotel + item.transport + item.fuel + item.meal + item.Misc;
//
ret.totals.fuel += item.fuel;
ret.totals.hotel += item.hotel;
ret.totals.meal += item.meal;
ret.totals.Misc += item.Misc;
ret.totals.total += item.total;
ret.totals.transport += item.transport;
//
ret.items.push(item);
//
curDate += msPerDay * Math.round(Math.random() * 4);
}
//
return ret;
}
}
body {
margin-bottom: 24px;
}
.grid {
margin-top: 20px;
height: 200px;
}
.wj-flexpie {
height: 250px;
}
import { PdfWebWorker } from '@mescius/wijmo.grid.pdf';
//
PdfWebWorker.initExportGrid();
import xmldom from 'xmldom';
import * as pdf from '@mescius/wijmo.pdf';
import * as gridPdf from '@mescius/wijmo.grid.pdf';
//
(<any>self).DOMParser = xmldom.DOMParser;
//
gridPdf.PdfWebWorker.initExport((doc: pdf.PdfDocument, clientData: gridPdf.IClientData) => {
gridPdf.PdfWebWorker.sendExportProgress(0);
//
doc.drawText(clientData['title'].content);
doc.drawImage(clientData['flag'].content);
doc.drawSvg(clientData['chart'].content);
//
// Suppose that text and images rendering takes 5% of the time.
gridPdf.PdfWebWorker.sendExportProgress(0.05);
//
let gridData = clientData['grid'];
gridData.settings.progress = (value: number) => {
// Change progress from 6% to 90%. Left the final 10% for the document finalization, which will start after the doc.end() method is called.
gridPdf.PdfWebWorker.sendExportProgress(map(value, 0, 1, 0.06, 0.9));
};
//
doc.ended.addHandler(() => {
// Document has been created, set progress to 100%.
gridPdf.PdfWebWorker.sendExportProgress(1);
});
//
gridPdf.FlexGridPdfConverter.draw(gridData.content, doc, null, null, gridData.settings);
//
doc.end();
});
//
function map(value: number, inMin: number, inMax: number, outMin: number, outMax: number) {
let k = (outMax - outMin) / (inMax - inMin);
return (value - inMin) * k + outMin;
}
declare function postMessage(message: any, transfer?: Transferable[]): void;
//
import * as pdf from '@mescius/wijmo.pdf';
import * as gridPdf from '@mescius/wijmo.grid.pdf';
//
addEventListener('message', (e) => {
let json = e.data.grid,
settings = JSON.parse(e.data.settings);
//
settings.documentOptions = settings.documentOptions || {};
//
settings.documentOptions.ended = (sender: pdf.PdfDocument, args: pdf.PdfDocumentEndedEventArgs) => {
postProgress(1); // 100%
//
// Convert Blob to a transferable object...
let fileReader = new FileReader();
fileReader.onload = (e) => {
let buffer = (<any>e.target).result;
// ...and send it to client.
postMessage({ data: buffer }, [buffer]);
};
fileReader.readAsArrayBuffer(args.blob);
};
//
settings.progress = (value: number) => {
postProgress(value * 0.9); // 0% to 90%
};
//
let doc = new pdf.PdfDocument(settings.documentOptions),
grid = gridPdf.PdfWebWorker.deserializeGrid(json, settings);
//
gridPdf.FlexGridPdfConverter.draw(grid, doc, null, null, settings);
//
doc.end();
});
//
function postProgress(value: number) {
postMessage({ type: 'progress', value: value });
}
(function (global) {
SystemJS.config({
transpiler: './plugin-typescript.js',
typescriptOptions: {
"target": "ES2022",
"module": "system",
"emitDecoratorMetadata": true,
"experimentalDecorators": true,
},
baseURL: 'node_modules/',
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'systemjs-plugin-css' },
'*.mjs': {
format: 'esm'
},
},
paths: {
// paths serve as alias
'npm:': ''
},
packageConfigPaths: [
'/node_modules/*/package.json',
"/node_modules/@angular/*/package.json",
"/node_modules/@mescius/*/package.json"
],
map: {
'core-js': 'https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js',
'typescript': 'https://cdnjs.cloudflare.com/ajax/libs/typescript/5.2.2/typescript.min.js',
"rxjs": "https://cdnjs.cloudflare.com/ajax/libs/rxjs/7.8.1/rxjs.umd.min.js",
'systemjs-plugin-css': 'https://cdn.jsdelivr.net/npm/systemjs-plugin-css@0.1.37/css.js',
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.angular2.chart.analytics": "npm:@mescius/wijmo.angular2.chart.analytics/index.js",
"@mescius/wijmo.angular2.chart.animation": "npm:@mescius/wijmo.angular2.chart.animation/index.js",
"@mescius/wijmo.angular2.chart.annotation": "npm:@mescius/wijmo.angular2.chart.annotation/index.js",
"@mescius/wijmo.angular2.chart.finance.analytics": "npm:@mescius/wijmo.angular2.chart.finance.analytics/index.js",
"@mescius/wijmo.angular2.chart.finance": "npm:@mescius/wijmo.angular2.chart.finance/index.js",
"@mescius/wijmo.angular2.chart.hierarchical": "npm:@mescius/wijmo.angular2.chart.hierarchical/index.js",
"@mescius/wijmo.angular2.chart.interaction": "npm:@mescius/wijmo.angular2.chart.interaction/index.js",
"@mescius/wijmo.angular2.chart.radar": "npm:@mescius/wijmo.angular2.chart.radar/index.js",
'@mescius/wijmo.angular2.chart.map': 'npm:@mescius/wijmo.angular2.chart.map/index.js',
"@mescius/wijmo.angular2.chart": "npm:@mescius/wijmo.angular2.chart/index.js",
"@mescius/wijmo.angular2.core": "npm:@mescius/wijmo.angular2.core/index.js",
"@mescius/wijmo.angular2.gauge": "npm:@mescius/wijmo.angular2.gauge/index.js",
"@mescius/wijmo.angular2.grid.detail": "npm:@mescius/wijmo.angular2.grid.detail/index.js",
"@mescius/wijmo.angular2.grid.filter": "npm:@mescius/wijmo.angular2.grid.filter/index.js",
"@mescius/wijmo.angular2.grid.grouppanel": "npm:@mescius/wijmo.angular2.grid.grouppanel/index.js",
"@mescius/wijmo.angular2.grid.search": "npm:@mescius/wijmo.angular2.grid.search/index.js",
"@mescius/wijmo.angular2.grid.multirow": "npm:@mescius/wijmo.angular2.grid.multirow/index.js",
"@mescius/wijmo.angular2.grid.sheet": "npm:@mescius/wijmo.angular2.grid.sheet/index.js",
'@mescius/wijmo.angular2.grid.transposed': 'npm:@mescius/wijmo.angular2.grid.transposed/index.js',
'@mescius/wijmo.angular2.grid.transposedmultirow': 'npm:@mescius/wijmo.angular2.grid.transposedmultirow/index.js',
"@mescius/wijmo.angular2.grid": "npm:@mescius/wijmo.angular2.grid/index.js",
"@mescius/wijmo.angular2.input": "npm:@mescius/wijmo.angular2.input/index.js",
"@mescius/wijmo.angular2.olap": "npm:@mescius/wijmo.angular2.olap/index.js",
"@mescius/wijmo.angular2.viewer": "npm:@mescius/wijmo.angular2.viewer/index.js",
"@mescius/wijmo.angular2.nav": "npm:@mescius/wijmo.angular2.nav/index.js",
"@mescius/wijmo.angular2.directivebase": "npm:@mescius/wijmo.angular2.directivebase/index.js",
'@mescius/wijmo.angular2.barcode.common': 'npm:@mescius/wijmo.angular2.barcode.common/index.js',
'@mescius/wijmo.angular2.barcode.composite': 'npm:@mescius/wijmo.angular2.barcode.composite/index.js',
'@mescius/wijmo.angular2.barcode.specialized': 'npm:@mescius/wijmo.angular2.barcode.specialized/index.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'jszip': 'https://cdnjs.cloudflare.com/ajax/libs/jszip/3.10.1/jszip.min.js',
'@angular/core': 'npm:@angular/core/fesm2022/core.mjs',
'@angular/core/primitives/signals': 'npm:@angular/core/fesm2022/primitives/signals.mjs',
'@angular/core/primitives/event-dispatch': 'npm:@angular/core/fesm2022/primitives/event-dispatch.mjs',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/http': 'npm:@angular/http/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
"./src": {
defaultExtension: 'ts'
},
"node_modules": {
defaultExtension: 'js'
},
wijmo: {
defaultExtension: 'js',
}
}
});
})(this);